{{
  FifoBig_Header.spin -- constants for a Ring buffer (Fifo) of "large" objects

Author:         Tom Dinger (Ding-Batty)
Release Date:   2024/02/21

Copyright 2024 Thomas E. Dinger

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.

--------------------------------------------------------------------------

  This file contains only the CONstants, that can be used either in SPIN code
  or in PASM code. In PASM, the Spin function implementations are not needed.
}}

CON
  ' Define the offsets to the fields of the header structure that describes
  ' the FIFO buffer. These are WORD fields.
  INSERT_HUBADDR_OFFSET   =  0
  REMOVE_HUBADDR_OFFSET   =  2
  START_HUBADDR_OFFSET    =  4
  LIMIT_HUBADDR_OFFSET    =  6
  ENTRY_SIZE_BYTES_OFFSET =  8

  HEADER_SIZE_BYTES = 12  ' Should be a multiple of 4 for LONG alignment
  HEADER_SIZE_WORDS = ((HEADER_SIZE_BYTES + 1) >> 1)
  ' Not an even number of longs, but we can round up.
  HEADER_SIZE_LONGS = ((HEADER_SIZE_BYTES + 3) >> 2)


'=====================================================================

PUB NoOp
  ' Needed for a "proper" object
